/*This file is part of GNU MlView
 *
 *GNU MlView is free software; you can redistribute it and/or modify it under the terms of 
 *the GNU General Public License as published by the Free Software Foundation; either version 2, 
 *or (at your option) any later version.
 *
 *GNU MlView is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; 
 *without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *See the GNU General Public License for more details.
 *
 *You should have received a copy of the GNU General Public License along with MlView; 
 *see the file COPYING. If not, write to the Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 *
 *Copyright 2001 dodji seketeli
 */

#ifndef __MLVIEW_UTILS_H__
#define __MLVIEW_UTILS_H__

#include <libxml/tree.h>
#include <libxml/parser.h>
#include <libxml/xmlerror.h>
#include <gnome.h>

#ifdef __cpluplus
extern "C"{
#endif //__cpluplus
	typedef enum {
		MLVIEW_UTILS_ERR_FILE_NAME_NULL=-1,
		MLVIEW_UTILS_ERR_BAD_FILE=-2,
		MLVIEW_UTILS_ERR_EMPTY_FILE=-3,
		MLVIEW_UTILS_ERR
	} MLVIEW_ERRORS ;
  
	int 
	load_xml_document(gchar * a_xmlfile, xmlParserCtxtPtr a_parser_context) ;

	void 
	get_xml_parser_error_as_string1(xmlParserCtxtPtr a_xml_parser_context, gchar * error_string) ;

	void 
	get_xml_parser_error_as_string2(xmlParserErrors a_xml_error, gchar * error_string) ;

	gboolean 
	utils_is_white_string(const gchar *a_str) ;

	void 
	utils_parse_full_name(xmlNode *a_node, gchar *a_full_name, 
			      xmlNs ** a_ns, gchar **a_local_name) ;

	xmlNs * 
	xmlUnlinkNs (xmlNode * node, xmlNs * ns) ;

	xmlNs * 
	xmlUnlinkNsDef (xmlNode * node, xmlNs * ns) ;

	int
	xmlValidGetValidElementsChildren (xmlNode *a_node, 
					  const xmlChar **a_list,
					  int a_max) ;

	gint 
	gtk_clist_row_absolute_top_ypixel (GtkCList *a_clist, 
					   gint a_row) ;

	gint 
	gtk_ctree_node_absolute_top_ypixel (GtkCTree * a_tree, 
					    GtkCTreeNode *a_node) ;

	void init_i18n (void) ;

#ifdef __cpluplus
}
#endif //__cpluplus
#endif
